/* AudioCaptureImp.c	-- Tomasz Stachowiak Tue Jan 14 1997
 * Time-stamp: <97/01/16 15:46:14 stach>
 */

#include <StubPreamble.h>
#include <dmedia/audio.h>
#include "AudioCapture.h"


void AudioCapture_capture(struct HAudioCapture *this,HArrayOfShort *buf, long len)
{
  static ALport micro;
  ALconfig conf;
  static int init = 0;
  long par[2];

  if(!init)
    {
      par[0] = AL_INPUT_RATE;
      par[1] = 8000;
      ALsetparams(AL_DEFAULT_DEVICE, par, 2);

      if ((conf = ALnewconfig()) == 0)
	fprintf (stderr, "Config allocation error\n");
      if (ALsetchannels(conf, 1) < 0)
	fprintf (stderr, "Setting channel error\n");
      if (ALsetqueuesize(conf, len) < 0)
	fprintf (stderr, "Setting queue size error\n");
      if (ALsetwidth(conf, AL_SAMPLE_16) < 0)
	fprintf (stderr, "Setting sample width error\n");

      if ((micro = ALopenport("microphone", "r", conf)) == 0)
	fprintf (stderr, "Port opening error");

      init = 1;
    }

  ALreadsamps(micro, unhand(buf)->body, len);
}


  
